<?php
/**
 * [PHPFOX_HEADER]
 */

defined('PHPFOX') or exit('NO DICE!');
class Phpfox_Gateway_Api_Paypal implements Phpfox_Gateway_Interface
{
	private $_aParam = array();
	private $_aCurrency = array('USD', 'GBP', 'EUR', 'AUD', 'CAD', 'JPY', 'NZD', 'CHF', 'HKD', 'SGD', 'SEK', 'DKK', 'PLN', 'NOK', 'HUF', 'CZK', 'ILS', 'MXN', 'BRL', 'MYR', 'PHP', 'TWD', 'THB');
	public function __construct()
	{
		
	}	
	
	public function set($aSetting)
	{
		$this->_aParam = $aSetting;
		
		if (Phpfox::getLib('parse.format')->isSerialized($aSetting['setting']))
		{
			$this->_aParam['setting'] = unserialize($aSetting['setting']);
		}
	}
	
	public function getEditForm()
	{
		return array(
			'ePayBank_api' => array(
				'phrase' => 'ePayBank API Code',
				'phrase_info' => 'The API code that represents your ePayBank gateway.',
				'value' => (isset($this->_aParam['setting']['ePayBank_api']) ? $this->_aParam['setting']['ePayBank_api'] : '')
			)
		);
	}
	
	public function getForm()
	{
		if (!in_array($this->_aParam['currency_code'], $this->_aCurrency))
		{
			if (isset($this->_aParam['alternative_cost']))
			{
				$aCosts = unserialize($this->_aParam['alternative_cost']);
				$bPassed = false;
				foreach ($aCosts as $sCode => $iPrice)
				{
					if (in_array($sCode, $this->_aCurrency))
					{
						$this->_aParam['amount'] = $iPrice;
						$this->_aParam['currency_code'] = $sCode;
						$bPassed = true;
						break;
					}
				}

				if ($bPassed === false)
				{
					return false;
				}
			}
			else
			{
				return false;
			}
		}

        $api = $this->_aParam['setting']['ePayBank_api'];
        $amount = $this->_aParam['amount'];
        $ReturnPath =  urlencode(Phpfox::getLib('gateway')->url('paypal'));//$this->_aParam['return'];
		
		@session_start();
       // $_SESSION['ResNumber'] = $this->_aParam['item_number'];//.'|'.$amount;

		
		$result = $this->_send($api,$amount,$ReturnPath);
		//$go = "http://ePayBank.ir/payment/gateway-$result";
		$_SESSION['price'] = $amount;
        
        if(filter_var($result, FILTER_VALIDATE_URL)){
            $aForm = array(
			'url' => $go ,
            'param' => array(
				'Price' => '1'
			)
    		);
            return $aForm;
        }
        else
        {
            return false;
        }
	}
	
	public function callback()
	{
		Phpfox::log('Starting ePayBank callback');

        $messagePage = '<html xmlns="http://www.w3.org/1999/xhtml">
        <head runat="server">
            <title>نتيجه پرداخت </title>
            <meta http-equiv="Content-Type" content="Type=text/html; charset=utf-8" />
        </head>
        <body style="text-align:center">
            <br/><br/><br/><br/>
            <div style="border: 1px solid;margin:auto;padding:15px 10px 15px 50px; width:600px;font-size:8pt; line-height:25px;$Style$">
             $Message$
            </div> <br /></br> <a href="/index.php" style="font:size:8pt ; color:#333333; font-family:tahoma; font-size:7pt" >بازگشت به صفحه اصلي</a>
        </body>
        </html>';

        $style = 'font-family:tahoma; text-align:right; direction:rtl';
        $style_succ = 'color: #4F8A10;background-color: #DFF2BF;'.$style;
        $style_alrt = 'color: #9F6000;background-color: #FEEFB3;'.$style;
        $style_errr = 'color: #D8000C;background-color: #FFBABA;'.$style;

        $api = $this->_aParam['setting']['ePayBank_api'];
		@session_start();
        //$aParts = explode('|',$_SESSION['ResNumber']);
	$rs=$_GET['rs'];
        $Price = $_SESSION['price'];

        Phpfox::log('Attempting callback');
		
        if( is_numeric($Price) )
        {
        		$result = $this->_get($api,$price,$rs);
        		if($result == '-33')// Your Peyment Code Only This Event
        		{
                    Phpfox::log('Callback OK');

                    Phpfox::log('Attempting to load module: ' . $aParts[0]);

        			if (Phpfox::isModule($aParts[0]))
        			{
        				Phpfox::log('Module is valid.');
        				Phpfox::log('Checking module callback for method: paymentApiCallback');
        				if (Phpfox::hasCallback($aParts[0], 'paymentApiCallback'))
        				{
        					Phpfox::log('Module callback is valid.');

        			  		$sStatus = 'completed';

        					Phpfox::log('Status built: ' . $sStatus);

      						Phpfox::log('Executing module callback');
      						Phpfox::callback($aParts[0] . '.paymentApiCallback', array(
      								'gateway' => 'paypal',
      								'ref' => $trans_id,
      								'status' => $sStatus,
      								'item_number' => $aParts[1],
      								'total_paid' => $Price
      							)
      						);
      						header('HTTP/1.1 200 OK');
                            $mss = 'کاربر گرامي ، عمليات پرداخت با موفقيت به پايان رسيد .<br><br>جهت پيگيري هاي آتي شماره رسيد پرداخت خود را ياداشت فرماييد : '.$rs.'<br> با تشکر <br>';
                            $messagePage = str_replace('$Message$',$mss,$messagePage);
                            $messagePage = str_replace('$Style$',$style_succ,$messagePage);
                            echo $messagePage;

                            return;
        				}
        				else
        				{
        					Phpfox::log('Module callback is not valid.');
        				}
        			}
        			else
        			{
        				Phpfox::log('Module is not valid.');
        			}
        		}
        		else
        		{
        			Phpfox::log('Callback '.$Status);
                   	$sStatus = $Status;
                    $mss = 'کاربر گرامي ، عمليات  اعتبار سنجي پرداخت شما با خطا مواجه گرديد .<br> درصورتي که پرداخت شما موفقيت آميز انجام شده باشد پس از بررسي اطلاعات پرداخت براي شما ارسال خواهد شد . <br> با تشکر <br> شماره پیگیری: '.$rs;
                    $messagePage = str_replace('$Message$',$mss,$messagePage);
                    $messagePage = str_replace('$Style$',$style_alrt,$messagePage);
                    echo $messagePage;
                    return;
        		}
	        }
          	else
      		{
      			Phpfox::log('Callback FAILED');
                $sStatus = 'cancel';
                header('HTTP/1.1 200 OK');
      		}
            $mss = 'پرداخت ناموفق / خطا در عمليات پرداخت ! کاربر گرامي ، فرايند پرداخت با خطا مواجه گرديد !<br> با تشکر <br>شماره پیگیری : '.$rs;
            $messagePage = str_replace('$Message$',$mss,$messagePage);
            $messagePage = str_replace('$Style$',$style_errr,$messagePage);
            echo $messagePage;
    }
	
	public function _send($api,$amount,$redirect){
require_once "./lib/nusoap.php";
$client=new nusoap_client("http://epaybank.ir/secure_gateway/ariacoders.php");
$error=$client->getError();
if($error){
echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
}
//$_SESSION["price"]=$amount;
$orderid=date('ymdhis');
$result=$client->call("requestpayment",array($api,$redirect,$amount,"parsian",$orderid));
$client->soap_defencoding = 'UTF-8';
if($client->fault){
	//echo "<h2>Fault</h2><pre>";
	return $result;
	//echo "</pre>";
}
else
{
$error=$client->getError();
	if($error)
	{
		return $error;
	}
	else
	{
		
		return $result;
		
	}
}///===================================
	}
	public function _get($api,$price,$rs){
require_once "./lib/nusoap.php";
$value=trim($price);
if(preg_match('/^[0-9]*$/',$value))
{
$client=new nusoap_client("http://epaybank.ir/secure_gateway/ariacoders.php");
$client->soap_defencoding = 'UTF-8';

$error=$client->getError();
if($error){
echo "<h2>Constructor Error</h2><pre>".$error."</pre>";
}
$result=$client->call("verifypeyment",array($api,$value,$rs,"parsian"));
$client->soap_defencoding = 'UTF-8';

if($client->fault){
	//echo "<h2>Fault</h2><pre>";
	return $result;
	//echo "</pre>";
}
else
{
$error=$client->getError();
	if($error){
		 return $error;
	}
	else
	{
		return $result;
		
	}
}
}//if first	
	}
}
?>
